#include "ini.hpp"
#include <alloc.h>

// This is a rather strange test of the .ini file capability.
// It does have pretty good coverage though.

main()
{
	cout << "Core:" << coreleft() << endl;
	InitFile & testIni = *(new InitFile("test.ini"));
	cout << "Core:" << coreleft() << endl;
	cout << testIni.find("Section 1", "value1", "crud") << endl
		<< testIni.find("Section 1", "value2", "dummy") << endl
		<< testIni.find("Section 1", "value3") << endl
		<< testIni.find("Section 1", "value4") << endl;
	cout << testIni.find("Section 2", "B.value1") << endl
		<< testIni.find("Section 2", "B.value2") << endl
		<< testIni.find("Section 2", "B.value4") << endl;
	if (testIni.find("Section 3", "B.value3")) cout << "ERROR!" << endl;
	cout << testIni.find("Section 0", "test", "TestValue") << endl
		<< testIni.find("Section 0", "lval", "rval") << endl
		<< testIni.find("Section 2", "lval!!", "rval!!") << endl;
	testIni.find("Section 1", "value22", "hahaha!");
	testIni.find("Section 1", "ABC", "DEFG");
	testIni.find("Section 1", "value5", "Who knows??");
	testIni.find("Section 3", "3.b", "Hoowie!");
	testIni.find("Section 3", "3.c", "Happiness in Slavery");
	testIni.find("Section 3", "3.a", "NIN");
	testIni.write();
	if( heapcheck() == _HEAPCORRUPT )
		cout << "Heap is corrupted." << endl;
	else
		cout << "Heap is OK." << endl;
	cout << "Core:" << coreleft() << endl;
	delete &testIni;
	if( heapcheck() == _HEAPCORRUPT )
		cout << "Heap is corrupted." << endl;
	else
		cout << "Heap is OK." << endl;

//	cout << "Core:" << coreleft() << endl;
//	InitFile::dealloc();
	cout << "Core:" << coreleft() << endl;
}
